<!doctype html>
<html lang="en">
    <head>
        <meta charset="UTF-8" />
        <title>My cool chat</title>
    </head>
    <body>
        <div class="center">
            <h1>WebSocket chat</h1>
            <h3 id="chat-header">Currently, in chat: general</h3>
            <h3 id="connection-header">Connected to WebSocket: false</h3>

            <form id="chatroom-selection">
                <label for="chatroom">
                    <input type="text" name="chatroom" id="chatroom" />
                    <br /><br />
                    <input type="submit" value="Change chatroom" />
                </label>
            </form>

            <textarea
                class="messagearea"
                id="chatmessages"
                readonly
                name="chatmessages"
                rows="4"
                cols="50"
                placeholder="Welcome to chat room"
            ></textarea>

            <br />

            <form id="chatroom-message">
                <label for="message">Message:</label>
                <input type="text" id="message" name="message" /> <br /><br />
                <input type="submit" value="Send message" />
            </form>

            <div style="border: 3px solid black; margin-top: 30px;">
                <form id="login-form">
                    <label for="username">username: </label>
                    <input type="text" id="username" name="username"> <br/>
                    <label for="password">password: </label>
                    <input type="text" id="password" name="password">  <br/>
                    <input type="submit" value="Login">
                </form>
            </div>
            
        </div>

        <script>
            var selectedChat = "general";

            class Event {
                constructor(type, payload) {
                    this.type = type;
                    this.payload = payload;
                }
            }

            class SendMessageEvent {
                constructor(mesasge, from) {
                    this.mesasge = mesasge;
                    this.from = from;
                }
            }

            class NewMessageEvent {
                constructor(mesasge, from, sent) {
                    this.mesasge = mesasge;
                    this.from = from;
                    this.sent = sent;
                }
            }

            function routeEvent(event) {
                if (event.type == undefined) {
                    alert("no type field in the event");
                }

                switch(event.type) {
                    case "new_message":
                        const messageEvent = Object.assign(new NewMessageEvent, event.payload)
                        appendChatMessage(messageEvent);
                        console.log("new message event type");
                        break;
                    default:
                        alert("unsupported message");
                }

            }

            function appendChatMessage(messageEvent) {
                var date = new Date(messageEvent.sent);
                const formattedMsg = `${date.toLocaleString()}: ${messageEvent.message}`;

                textArea = document.getElementById("chatmessages");
                textArea.innerHTML = textArea.innerHTML + "\n" + formattedMsg;
                textArea.scrollTop = textArea.scrollHeight;
            }

            function sendEvent(eventName, payload) {
                const event = new Event(eventName, payload)
                conn.send(JSON.stringify(event))
            }

            function changeChatRoom() {
                var newchat = document.getElementById("chatroom");
                if (newchat != null && newchat.value != selectedChat) {
                    console.log(newchat);
                }
                return false;
            }

            function sendMessage() {
                var newMessage = document.getElementById("message");
                if (newMessage != null) {
                    let outgoingEvent = new SendMessageEvent(newMessage.value, "artem")
                    sendEvent("send_message", outgoingEvent)
                }
                return false;
            }

            function login() {
                let formData = {
                    "username": document.getElementById("username").value,
                    "password": document.getElementById("password").value,
                }

                fetch("login", {
                    method: 'post', 
                    body: JSON.stringify(formData)
                }).then((response) => {
                    if (response.ok) {
                        return response.json()
                    } else {
                        throw 'unauthorized'
                    }
                }).then((data) => {
                    // we are authenticated
                    connectWebsocket(data.otp);
                }).catch((e) => {
                    alert("unauthenticated")
                });

                return false;
            }

            function connectWebsocket(otp) {
                if (window["WebSocket"]) {
                    console.log("supports websockets");
                    conn = new WebSocket("ws://" + document.location.host + "/ws?otp=" + otp);

                    conn.onopen = function(evt) {
                        document.getElementById("connection-header").innerHTML = "Connected to WebSocket: true";
                    }

                    conn.onclose = function(evt) {
                        document.getElementById("connection-header").innerHTML = "Connected to WebSocket: false";
                        // reconnection
                    }

                    conn.onmessage = function(evt) {
                        const eventData = JSON.parse(evt.data);
                        const event = Object.assign(new Event, eventData);
                        routeEvent(event)
                    }

                } else {
                    console.log("browser does not support websockets");
                }
            }

            window.onload = function () {
                document.getElementById("chatroom-selection").onsubmit =
                    changeChatRoom;
                document.getElementById("chatroom-message").onsubmit =
                    sendMessage;
                document.getElementById("login-form").onsubmit = 
                    login;
            };
        </script>

        <style type="text/css">
            body {
                overflow: hidden;
                padding: 0;
                margin: 0;
                width: 100%;
                height: 100%;
            }

            .center {
                margin: auto;
                width: 50%;
                border: 3px solid green;
            }
        </style>
    </body>
</html>
